﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
' Static Code Module
Sub Process_Globals
	' Declare global variables
	Private fx As JFX
	Private MainForm As Form
	Private xui As XUI
	Dim UI As jdashboard_WindowsStyle
	Private BT_CERRAR As Button
	Private BT_MIN As Button
	Private BT_MAX As Button

	Private WD As WordUtils
	Dim xl As XLUtils

	Private Ribbon1 As Ribbon
	Dim datos As jdProperties

	Private iconsfont As JIconFont
	Private JTableview1 As JTableview
	Private combo As ComboBox

	Private DBdir As String = ""
	Private notif As JNotificationBar
End Sub

' Main method to initialize and display the UI
Sub Show
	' Initialize UI components
	iconsfont.Initialize
	iconsfont.FontSize = 45
	WD.Initialize
	MainForm.Initialize("MainForm", 1000, 600)
	MainForm.SetFormStyle("UNDECORATED")

	' Configure main UI style
	UI.Initialize(Me, MainForm, "UI", fx.Colors.ARGB(240, 16, 124, 65))
	UI.Title.Text = "Your app name"
	MainForm.Title = "Your app name"
	UI.titlestyle(xui.Color_RGB(16, 124, 65))
	UI.Title.TextColor = fx.Colors.White
	UI.AnimationsActivated = False
	UI.SetIcon(xui.LoadBitmap(File.DirAssets, "web_512px.png"))
	MainForm.Icon = xui.LoadBitmap(File.DirAssets, "web_512px.png")

	' Create and configure buttons
	BT_CERRAR = UI.ButtonAdd("")
	BT_MAX = UI.ButtonAdd("")
	BT_MIN = UI.ButtonAdd("")
	jdashboardUtils.ButtonSeticon(BT_CERRAR, Chr(0xE14C), fx.Colors.White, fx.CreateMaterialIcons(20), fx.Colors.Transparent, "LEFT")
	BT_CERRAR.Tag = "exit"
	jdashboardUtils.ButtonSeticon(BT_MIN, Chr(0xE15B), fx.Colors.White, fx.CreateMaterialIcons(20), fx.Colors.Transparent, "LEFT")
	jdashboardUtils.ButtonSeticon(BT_MAX, Chr(0xE069), fx.Colors.White, fx.CreateMaterialIcons(20), fx.Colors.Transparent, "LEFT")
	UI.ButtonBindToAction(BT_CERRAR, UI.ACTION_EXIT)
	UI.ButtonBindToAction(BT_MAX, UI.ACTION_MAXIMIZE)
	UI.ButtonBindToAction(BT_MIN, UI.ACTION_MINIMIZE)

	' Initialize and load database configurations
	datos.Initialize("configuraciones", "configuraciones.db")
	If datos.Exists("ruta") = False Then datos.Put("ruta", "")
	If datos.Exists("iva") = False Then datos.Put("iva", "")
	If datos.Exists("basico") = False Then datos.Put("basico", "")

	' Configure UI properties
	UI.MenuType = UI.No_menu
	UI.AnimationsActivated = False
	UI.BorderWidth = 9
	UI.RootPane.LoadLayout("Layout1")
	MainForm.Show

	' Initialize notification bar
	notif.Initialize
	notif.BackgroundColor = fx.Colors.To32Bit(UI.ColorUI)

	' Initialize and display ribbon
	
	Ribbon
End Sub

' Handle main form resizing
Sub MainForm_Resize(Width As Double, Height As Double)
	UI.resize
End Sub

' Initialize ribbon with all sections
Sub Ribbon
	Ribbon1.RemoveAllTabs
	RibbonStart
	RibbonDatabase
	RibbonHelp
End Sub

#Region "Ribbon Sections"

' Initialize the "Start" ribbon tab
Sub RibbonStart
	Private RibbonTab1 As RibbonTab
	Private RibbonGroup1, RibbonGroup2, Clipboard, Alignment As RibbonGroup
	Private ClipboardButtonGroup As RibbonButtonGroup
	Private smart1, smart2 As RibbonSmartButtonGroup
	Private new, Open, save, saveas, print, printpreview, undo, redo, encrypt, properties, Calc As Button
	Private justify, left, right, center As Button
	Private paste, cut, copy, paste2 As Button

	' Setup ribbon tab and groups
	RibbonTab1.Initialize(Me, "RibbonTab1", "Start")
	RibbonGroup1.Initialize(Me, "Group 1", "RibbonGroup1")
	RibbonGroup1.AddTitle("Start")
	RibbonGroup2.Initialize(Me, "Info", "RibbonGroup2")
	Clipboard.Initialize(Me, "Clipboard", "Clipboard")
	ClipboardButtonGroup.Initialize(Me, "")

	' Initialize buttons
	new.Initialize("new")
	Open.Initialize("Open")
	save.Initialize("save")
	saveas.Initialize("saveas")
	print.Initialize("print")
	printpreview.Initialize("printpreview")
	undo.Initialize("undo")
	redo.Initialize("redo")
	encrypt.Initialize("encrypt")
	properties.Initialize("properties")
	Calc.Initialize("calc")
	justify.Initialize("justify")
	left.Initialize("left")
	right.Initialize("right")
	center.Initialize("center")
	paste.Initialize("paste")
	cut.Initialize("cut")
	copy.Initialize("copy")
	paste2.Initialize("paste2")
	smart1.Initialize(Me, "")
	smart2.Initialize(Me, "")

	' Configure buttons and add them to groups
	RibbonGroup1.AddButtonImage(new, File.DirAssets, "table@512px.png", 45, "New file", "Create a new document")
	RibbonGroup1.AddButtonIcon(Open, iconsfont.IconFontAwesomeRegular, Chr(0xf07c), xui.Color_RGB(217, 193, 105), "Open File", "Open a document")
	RibbonGroup1.AddButtonImage(save, File.DirAssets, "save@512px.png", 45, "Save", "Save the document")
	RibbonGroup1.AddButtonIcon(Calc, iconsfont.IconFontAwesomeSolid, Chr(0xf64c), xui.Color_RGB(86, 137, 199), "Open calculator", "Open the calculator")
	
	RibbonGroup2.AddButtonImage(properties, File.DirAssets, "settings@512px.png", 45, "Document properties", "Document properties")
	RibbonGroup2.AddButtonIcon(encrypt, iconsfont.IconFontAwesomeSolid, Chr(0xe573), xui.Color_RGB(111, 171, 142), "Encrypt with password", "Encrypt the document")
	
	Clipboard.AddButtonImage(paste, File.DirAssets, "clipboard@512px.png", 45, "Paste", "Paste from clipboard")
	ClipboardButtonGroup.AddButtonImage(cut, File.DirAssets, "clipboard-cut@512px.png", 22, "Cut", "")
	ClipboardButtonGroup.AddButtonImage(copy, File.DirAssets, "clipboard-copy@512px.png", 22, "Copy", "")
	ClipboardButtonGroup.AddButtonImage(paste2, File.DirAssets, "clipboard-paste@512px.png", 22, "Paste Special", "")
	Clipboard.AddButtonGroup(ClipboardButtonGroup)

	' Alignment group
	smart1.AddButtonIcon(justify, xui.CreateFont2(iconsfont.IconFontAwesomeSolid, 22), Chr(0xf039), fx.Colors.RGB(206, 117, 184), "Justify text")
	smart1.AddButtonIcon(left, xui.CreateFont2(iconsfont.IconFontAwesomeSolid, 22), Chr(0xf036), fx.Colors.RGB(206, 117, 184), "Align left")
	smart1.AddButtonIcon(right, xui.CreateFont2(iconsfont.IconFontAwesomeSolid, 22), Chr(0xf038), fx.Colors.RGB(206, 117, 184), "Align right")
	smart2.AddButtonIcon(center, xui.CreateFont2(iconsfont.IconFontAwesomeSolid, 22), Chr(0xf037), fx.Colors.RGB(206, 117, 184), "Center text")
	Alignment.Initialize(Me, "Alignment", "")
	Alignment.AddSmartButtonGroup(smart1)
	Alignment.AddSmartButtonGroup(smart2)

	' Add groups to ribbon tab
	RibbonTab1.AddGroup(RibbonGroup1)
	RibbonTab1.AddGroup(RibbonGroup2)
	RibbonTab1.AddGroup(Clipboard)
	RibbonTab1.AddGroup(Alignment)
	Ribbon1.AddTab(RibbonTab1)
End Sub

' Initialize the "Database" ribbon tab
Sub RibbonDatabase
	Private RibbonTab3 As RibbonTab
	Private Files, Tables As RibbonGroup
	Private OpenDB, SaveDB As Button

	RibbonTab3.Initialize(Me, "RibbonTab3", "Database")
	OpenDB.Initialize("OpenDB")
	SaveDB.Initialize("SaveDB")
	Files.Initialize(Me, "Files", "")
	Tables.Initialize(Me, "Tables", "")

	Files.AddButtonIcon(OpenDB, iconsfont.IconFontAwesomeRegular, Chr(0xf07c), xui.Color_RGB(217, 193, 105), "Open Database", "Open a database file")
	Files.AddButtonImage(SaveDB, File.DirAssets, "save@512px.png", 45, "Save Database", "Save the database")
	Tables.AddView(ComboboxPanel)

	RibbonTab3.AddGroup(Files)
	RibbonTab3.AddGroup(Tables)
	Ribbon1.AddTab(RibbonTab3)
End Sub

' Initialize the "Help" ribbon tab
Sub RibbonHelp
	Private RibbonTab4 As RibbonTab
	Private gayuda As RibbonGroup
	Private ayuda As Button

	RibbonTab4.Initialize(Me, "RibbonTab4", "Help")
	ayuda.Initialize("help")
	gayuda.Initialize(Me, "Help", "gayuda")

	gayuda.AddButtonIcon(ayuda, iconsfont.IconFontAwesomeSolid, Chr(0xf05a), xui.Color_RGB(102, 168, 255), "About", "Information about the application and author")
	RibbonTab4.AddGroup(gayuda)
	Ribbon1.AddTab(RibbonTab4)
End Sub

#End Region

' Create a panel with a combo box for table selection
Public Sub ComboboxPanel As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	Dim l As B4XView = jdashboardUtils.CreateLabel("")
	l.Font = xui.CreateDefaultBoldFont(12)
	l.Text = "Select table:"
	p.Width = 200dip
	combo.Initialize("combo")
	combo.Items.Clear
	p.AddView(l, 10dip, 10dip, 180dip, 30dip)
	p.AddView(combo, 10dip, 40dip, 180dip, 10dip)
	Return p
End Sub

#Region "Button Handlers"

' Click event for the "calculator" button
Private Sub calc_Click
	Dim shl As Shell
	shl.Initialize("shl", "cmd.exe", Array As String("/C", "start", "calc.exe"))
	shl.Run(-1)
End Sub

' Open a database file
Private Sub OpenDB_Click
	Try
		Dim FC As FileChooser
		FC.Initialize
		FileChooserUtils.AddExtensionFilters2(FC, Array As String("Database"), Array As String("*.db"), "Database File")
		Dim ruta As String = FC.ShowOpen(MainForm)
		DBdir = ruta
		Dim L As List = JTableview1.ListAllTablesDB(ruta, Main.SQL)
		combo.Items.Clear
		For Each M As String In L
			combo.Items.Add(M)
		Next
		JTableview1.LoadSQLTable(ruta, L.Get(0), Main.SQL)
		combo.SelectedIndex = 0
	Catch
		Log(LastException)
	End Try
End Sub

' Save changes to the database
Private Sub SaveDB_Click
	JTableview1.UpdateSqlTable(combo.Value, Main.SQL)
End Sub

' Event triggered when the SQL table is updated
Private Sub JTableview1_TableSqlUpdated(Success As Boolean)
	If Success Then
		JTableview1.LoadSQLTable(DBdir, combo.Value, Main.SQL)
		notif.Text = $"Changes to the table ${combo.value} have been saved."$
	Else
		notif.Text = $"Error: The table ${combo.value} could not be updated."$
	End If
	notif.Show(UI.RootPane)
End Sub

' Event triggered when the combo box value changes
Private Sub combo_ValueChanged(Value As Object)
	JTableview1.LoadSQLTable(DBdir, Value, Main.SQL)
End Sub

' Click event for the "About" button
Private Sub help_Click
	about.Show(MainForm)
End Sub

#End Region

#Region "UI Event Handlers"

' Mouse entered event for buttons
Sub UI_MouseEntered(ButtonSender As Button, EventData As MouseEvent)
	If ButtonSender.Tag = "exit" Then
		CSSUtils.SetBackgroundColor(ButtonSender, fx.Colors.RGB(229, 69, 75))
	Else
		CSSUtils.SetBackgroundColor(ButtonSender, fx.Colors.RGB(52, 55, 62))
	End If
End Sub

' Mouse exited event for buttons
Sub UI_MouseExited(ButtonSender As Button, EventData As MouseEvent)
	CSSUtils.SetBackgroundColor(ButtonSender, fx.Colors.Transparent)
End Sub

' Mouse clicked event for buttons
Sub UI_MouseClicked(ButtonSender As Button, EventData As MouseEvent)
	If ButtonSender.Tag = "save" Then
		Log("Save button pressed")
	End If
End Sub

' Handle color changes in JTableView
Private Sub JTableview1_TableColorChanged(Color As Int)
	
	Ribbon1.SelectColor = Color
	UI.ColorUI = jdashboardUtils.SetAlphaToPaintColor(fx.Colors.From32Bit(Color), 230)
	UI.titlestyle(Color)
	notif.BackgroundColor = fx.Colors.To32Bit(UI.ColorUI)
	

End Sub

#End Region




#Region Funtions
Sub LoadExcel
	Try
		' Initialize FileChooser
		Dim FC As FileChooser
		FC.Initialize

		' Configure the file filter for Excel files
		FileChooserUtils.AddExtensionFilters2(FC, Array As String("Microsoft Excel"), Array As String("*.xlsx"), "Excel File")

		' Open file and get the selected path
		Dim ruta As String = FC.ShowOpen(MainForm)

		' Initialize XLUtils and load the Excel sheet
		Dim xl As XLUtils
		xl.Initialize
		Dim Libraries As XLReaderResult = xl.Reader.ReadSheetByIndex(ruta, "", 0)

		' Initialize column titles list
		Dim titles As List
		titles.Initialize

		' Generate column names (e.g., A, B, C... AA, AB...)
		For i = 0 To Libraries.BottomRight.Col0Based
			Dim columnName As String = JTableview1.GetExcelColumnName(i)
			titles.Add(columnName)
		Next

		' Log the column titles for debugging
		Log(titles)

		' Clear the table
		JTableview1.Clear

		' Set column headers in the table
		JTableview1.SetColumns(titles)

		' Set column widths
		JTableview1.AllColumnTableWidth = 180

		' Log the number of rows for verification
		Log("BottomRight.Row0Based: " & Libraries.BottomRight.Row0Based)

		' Check if there are rows in the table
		If Libraries.BottomRight.Row0Based >= 0 Then
			' Process all rows
			For Row1Based = 1 To Libraries.BottomRight.Row0Based + 1
				' Ensure the array size matches the number of columns
				Dim row1(titles.Size) As Object

				' Populate each column in the row
				For i = 0 To titles.Size - 1
					row1(i) = JTableview1.CreateLabel(Libraries.Get(xl.AddressZero(i, Row1Based - 1)), Libraries.Get(xl.AddressZero(i, Row1Based - 1)), fx.Colors.RGB(80, 80, 80))
				Next

				' Add the row to the table
				JTableview1.Add(row1)

				' Log to confirm the row was added
				Log("Row " & Row1Based & " added to TableView")
			Next
		Else
			Log("No rows to process")
		End If

	Catch
		' Log any exception that occurs
		Log(LastException)
	End Try
End Sub


#End region

