﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
' Static code module for a custom "About" form
Sub Process_Globals
	' Declare global variables
	Private fx As JFX
	Dim xui As XUI
	Dim Submit As jButton       ' Submit button
	Dim close As Button         ' Close button
	Private frm As custom_form  ' Custom form instance
End Sub

' Shows the "About" form, accepts a parent form as a parameter
Public Sub show(Parent As Form)
	' Initialize the custom form
	frm.Initialize
	frm.imageicon = xui.LoadBitmap(File.DirAssets, "web_512px.png")
	frm.colorpanel = fx.Colors.Transparent
	frm.colorui = fx.Colors.RGB(61, 67, 84)  ' Background color
	frm.title = "About Your App"
	frm.borders = 5                          ' Border size
	frm.show(Me, "frm", 600dip, 400dip, Parent)

	' Create and add an image view with an icon
	Dim img As JImageView = jdashboardUtils.CreateJImageView(150, 150)
	img.Load(File.DirAssets, "web_512px.png")
	img.ResizeMode = "FILL_NO_DISTORTIONS"   ' Ensures proper scaling
	frm.panel.AddView(img.mBase, 5, 10, 150, 150)

	' Create and configure a TextFlow for displaying "About" information
	Dim tf As TextFlow
	tf.Initialize
	tf.AddText("Your App Name").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 17, True, False)).AddText(CRLF).AddText(CRLF)
	tf.AddText("Version: ").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 14, True, False)).AddText("1.0").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 12, False, False)).AddText(CRLF)
	tf.AddText("Developed by: ").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 14, True, False)).AddText("Fernando Arevalo").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 12, False, False)).AddText(CRLF)
	tf.AddText("Release Date: ").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 14, True, False)).AddText("03/10/2024").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 12, False, False)).AddText(CRLF)
	tf.AddText("Platform: ").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 14, True, False)).AddText("Windows").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 12, False, False)).AddText(CRLF).AddText(CRLF)
	tf.AddText("Description: ").SetColor(xui.Color_Gray).SetFont(fx.CreateFont("", 14, True, False)).AddText(CRLF)
	tf.AddText("Your app description.").SetColor(xui.Color_White).SetFont(fx.CreateFont("", 12, False, False)).AddText(CRLF).AddText(CRLF)
	tf.AddText("Thank you for using this app!").SetColor(xui.Color_Gray).SetFont(fx.CreateFont("", 12, True, False))

	' Add the TextFlow pane to the form
	Dim pane As Pane = tf.CreateTextFlow("LEFT", "CENTER")
	frm.panel.AddView(pane, 160, 5, 370, 240)

	' Initialize and configure the Submit button
	Submit.Initialize(Me, "lblSubmit")
	Submit.AddToParent(frm.panel, 200, 300, 200, 40, 1, 15, "Accept", xui.Color_White, xui.PaintOrColorToColor(Started.UI.ColorUI), xui.PaintOrColorToColor(Started.UI.ColorUI), "LEFT_RIGHT", 5)

	' Configure and add the close button with an icon
	frm.setAddButtomIcon(close, "", fx.Colors.White, Chr(0xF00D), xui.CreateFontAwesome(25), fx.Colors.White, fx.Colors.Transparent, "close", "exit")

	' Set focus to the Submit button and start the form
	Submit.mBase.RequestFocus
	frm.Start
End Sub

' Event handler for the Submit button click
Private Sub lblSubmit_Click
	' Close the form when Submit is clicked
	frm.Close
End Sub

' Event handler for the form's close button click
Private Sub frm_MouseClicked(ButtonSender As Button, EventData As MouseEvent)
	' Close the form if the button's tag is "exit"
	If ButtonSender.Tag = "exit" Then
		frm.Close
	End If
End Sub
